<img src="https://www.cyric.eu/wp-content/uploads/2019/10/Untitled-1.png" alt="OPTeBOXLogo" width="250" />

# 1. Prerequisites

## 1.1 Ensure You Have Docker Installed

Make sure Docker is installed and running on your machine. Docker can be downloaded from its official website.

No other prerequisites are necessary if the container is setup correctly in the following steps, as all other requirements are handled when building the container.

# 2. Set up docker container

## 2.1 Compose Docker container

`$ docker compose up --build -d`

## 2.2 Initialise the container

`$ docker exec -it cyric_routing bash`

# 3. Running the app 

## Check the Configurations

1. Open the config.py file.
2. Ensure that USE_EXTERNAL_API is set to False if you want to use the local CSV file for testing.
3. Ensure that POST_EXTERNAL_API is not False if you want to post the solution. Additionaly change the POST_EXTERNAL_API_URL and use that to POST the result.
4. Change number of drivers if need.
5. Extend this config with any other static information depending on your use case

## Test the Application

In the docker terminal in the directory where main.py is located, run:

` $ python main.py`

This example app is designed to take samples of all pilar boxes and simulate a daily request with occupied boxes.

Solution is quite verbose and therefore printed in the console as it executes.

Accessing `http://localhost:5000/optimize` will run the main logic and return a response JSON.

The application should exit after that.

# 4. Extend the application

This container is built as a flask app to send these results through APIs. While some functionality for this is provided, you will need to extend the implementation to connect it with your APIs and ensure that requests are timely handled on wake.


# 5. Contact
If you encounter any problems, please contact the following:

[<img src="https://www.cyric.eu/wp-content/uploads/2017/04/cyric_logo_2017.svg" alt="CyRIC | Cyprus Research and Innovation Centre" width="150" />](mailto:info@cyric.eu)

# 6. License

All software components listed under this repository are licensed under:

[Apache-2.0](LICENSE)

# 7. Acknowledgments

* [OpteBox project](https://www.cyric.eu/project/optebox/)
The project is co-funded by the Republic of Cyprus and European Union via Research and Innovation Foundation’s project number ENTERPRISES/0521/0206
[<img src="https://www.cyric.eu/wp-content/uploads/2023/06/co-funded-by-the-Republic-of-Cyprus-and-European-Union-1024x109.jpg" alt="epublic of Cyprus and European Union via Research and Innovation Foundation" width="350" />]


